/**
 **	File ......... BlackAdder.h
 **	Published ....  2004-05-17
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _BLACKADDER_H
#define _BLACKADDER_H


	typedef std::vector<std::string> string_v;
	typedef std::map<std::string,std::string> strstr_m;


typedef struct
{
	std::string name; // classname
	std::string filename;
	int line;
	bool bExtern;
	bool bUsed;
	string_v bases; // basklasser
	string_v using_type;
} CLS;


typedef struct
{
	std::string name; // space
	std::vector<CLS *> added; // klasser
} NSP;



class BlackAdder
{
	typedef std::map<std::string,std::vector<std::string> > typedef_m;

public:
	BlackAdder();
	~BlackAdder();

	CLS *add_class(const std::string &,string_v &,const std::string &,int,bool);
	NSP *GetNamespace(const std::string &name);
	void MakeDot();
	void add_using(const std::string &);
	void clear_using();
	void add_type(CLS *,const std::string &);
	void set_typedef(const std::string &,std::vector<std::string>&);

private:
	void fix_class();
	CLS *find_class(const std::string &,const std::string &);
	bool locate(NSP *base,const char *,NSP *&,CLS *&);
	//
	std::vector<NSP *> m_added; // namespaces
	strstr_m m_using;
	typedef_m m_typedef;
};


#endif // _BLACKADDER_H
