/**
 **	File ......... Sequence.h
 **	Published ....  2004-05-17
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _SEQUENCE_H
#define _SEQUENCE_H



class Scope;

class Sequence
{
public:
	Sequence();
	Sequence(token_v &);
	virtual ~Sequence();

	void SetFile(const std::string &file) { m_file = file; }
	std::string GetFile() { return m_file; }
	void SetLine(int line) { m_line = line; }
	int GetLine() { return m_line; }
	void SetPos(int pos) { m_pos = pos; }
	int GetPos() { return m_pos; }
	void SetExtern(bool x) { m_bExtern = x; }
	bool IsExtern() { return m_bExtern; }

	void SetParent(Scope *p) { m_parent = p; }
	Scope *GetParent() { return m_parent; }

	virtual void Display();
	void Tab();
	std::string GetExpr();
	void xmlsafestr(std::string &);

	Token *GetFirstToken();
	token_v::iterator Begin() { return m_tokens.begin(); }
	token_v::iterator End() { return m_tokens.end(); }

private:
	std::string m_file;
	int m_line;
	int m_pos;
	bool m_bExtern;
	token_v m_tokens;
	Scope *m_parent;
};

typedef std::vector<Sequence *> sequence_v;


#endif // _SEQUENCE_H
